/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.drivers.sde;

import java.awt.geom.Rectangle2D;
import java.sql.Connection;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.drivers.DBLayerDefinition;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;
import com.iver.cit.gvsig.fmap.drivers.IVectorialDatabaseDriver;
import com.iver.cit.gvsig.fmap.layers.XMLException;
import com.iver.utiles.XMLEntity;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public interface IVectorialSDEDriver extends IVectorialDatabaseDriver {
    //public Connection getConnection();
    public IFeatureIterator getFeatureIterator(String sql)
        throws DriverException;

    //public String getConnectionStringBeginning();
    public void open() throws com.iver.cit.gvsig.fmap.DriverException;

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public int getDefaultPort();

    /**
     * DOCUMENT ME!
     *
     * @param rect DOCUMENT ME!
     */
    public void setWorkingArea(Rectangle2D rect);

    /**
     * DOCUMENT ME!
     *
     * @return
     */
    public Rectangle2D getWorkingArea();

    /**
     * DOCUMENT ME!
     *
     * @param _host DOCUMENT ME!
     * @param _port DOCUMENT ME!
     * @param _db DOCUMENT ME!
     * @param _user DOCUMENT ME!
     * @param _pw DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getConnectionString(String _host, String _port, String _db,
        String _user, String _pw);

	public String getTableName();

	public XMLEntity getXMLEntity();

	public void setXMLEntity(XMLEntity entity) throws XMLException;

	public void close();

	public int getRowIndexByFID(IFeature feat);

	public DBLayerDefinition getLyrDef();

	public String getWhereClause();

	public String[] getFields();

	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG, String[] alphaNumericFieldsNeeded) throws DriverException;

	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG) throws DriverException;

    //	public String[] getTableNames(Object conex, String dbName) throws SQLException;
    //	public String[] getAllFields(Object conn, String tableName);
    //	public String[] getAllFieldTypeNames(Object conn, String tableName);
    //	public String[] getIdFieldsCandidates(Object conn, String tableName);
    //	public String[] getGeometryFieldsCandidates(Object conn, String tableName);
}
