package com.iver.cit.gvsig.fmap.layers;

import java.awt.geom.Rectangle2D;
import java.io.IOException;

import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DBLayerDefinition;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;
import com.iver.cit.gvsig.fmap.drivers.sde.IVectorialSDEDriver;
import com.iver.cit.gvsig.fmap.layers.VectorialDBAdapter;

public class VectorialSDEAdapter extends VectorialDBAdapter{
	/**
	 * incrementa el contador de las veces que se ha abierto el fichero.
	 * Solamente cuando el contador est a cero pide al driver que conecte con
	 * la base de datos
	 */
	public void start() {
            try {
            	//System.out.println("====" +this.hashCode()+" Abrir tabla: " + ((VectorialSDEDriver)driver).getTableName());
                ((IVectorialSDEDriver)driver).open();
            } catch (DriverException e) {

            	NotificationManager.addError(e);
            }
	}

	/**
	 * decrementa el contador de nmero de aperturas y cuando llega a cero pide
	 * al driver que cierre la conexion con el servidor de base de datos
	 */
	public void stop() {
		//System.out.println("====" +this.hashCode()+" Cerrar tabla: " + ((VectorialSDEDriver)driver).getTableName());
	    ((IVectorialSDEDriver)driver).close();
	}
	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG) throws DriverException
	{
	    return ((IVectorialSDEDriver)driver).getFeatureIterator(r, strEPSG);
	}

    /* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.layers.ISpatialDB#getFeatureIterator(java.awt.geom.Rectangle2D, java.lang.String, java.lang.String[])
	 */
    public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG, String[] alphaNumericFieldsNeeded) throws DriverException
    {
        return ((IVectorialSDEDriver)driver).getFeatureIterator(r, strEPSG, alphaNumericFieldsNeeded);
    }

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.layers.ISpatialDB#getFields()
	 */
	public String[] getFields()
	{
	    return ((IVectorialSDEDriver)driver).getFields();
	}
	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.layers.ISpatialDB#getWhereClause()
	 */
	public String getWhereClause()
	{
	    return ((IVectorialSDEDriver)driver).getWhereClause();
	}
	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.layers.ISpatialDB#getTableName()
	 */
	public String getTableName()
	{
	    return ((IVectorialSDEDriver)driver).getTableName();
	}


	/**
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getShape(int)
	 */
	public IGeometry getShape(int index) throws DriverIOException {
	    IGeometry geom = null;
	    try {
            geom = ((IVectorialSDEDriver)driver).getShape(index);
        } catch (IOException e) {
            throw new DriverIOException(e);
        }
	    return geom;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getShapeType()
	 */
	public int getShapeType() throws DriverIOException {
		return ((IVectorialSDEDriver)driver).getShapeType();
	}
	 /* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.layers.ISpatialDB#getLyrDef()
	 */
    public DBLayerDefinition getLyrDef()
    {
        return ((IVectorialSDEDriver)driver).getLyrDef();
    }

	public int getRowIndexByFID(IFeature feat) {
		return ((IVectorialSDEDriver) driver).getRowIndexByFID(feat);
	}
}
